<?php
/*
Plugin Name: Really Close Old Posts
Plugin URI: http://www.timlinden.com/blog/wordpress-plugins/really-close-old-posts/
Description: Closes comments on old posts on the fly, *with* DB queries. By default it's 14 days, change that setting by editing the plugin file. Based on Matt Mullenweg's 'Close Old Posts' which doesn't modify the DB.
Author: Tim Linden
Version: 1.1
Author URI: http://www.timlinden.com/blog/
*/ 

$cop_days_old = 14; // close comments after this many days

function really_close_old_posts( $posts ) {
	if ( !is_single() )
		return $posts;

	global $cop_days_old, $wpdb;
	$too_old = $cop_days_old * 24 * 60 * 60;
	if ( time() - strtotime( $posts[0]->post_date_gmt ) > ( $cop_days_old * 24 * 60 * 60 ) && $posts[0]->ping_status != 'closed' ) {
		$posts[0]->comment_status = 'closed';
		$posts[0]->ping_status = 'closed';
		$wpdb->query("UPDATE $wpdb->posts SET comment_status = 'closed', ping_status = 'closed' WHERE ID = ".$posts[0]->ID);
	}
	return $posts;
}

add_filter( 'the_posts', 'really_close_old_posts' );

?>